var nodejs = (typeof window === 'undefined');
if(nodejs) {
  WebGL = require('../../index');
  document = WebGL.document();
  alert=console.log;
  window = document;

  //Read and eval library
  var fs=require('fs');
  eval(fs.readFileSync(__dirname+ '/lightgl.js','utf8'));
}

document.setTitle("Camera");
requestAnimationFrame = document.requestAnimationFrame;

var angleX = -35;
var angleY = 45;
var gl = GL.create();
var camera = new GL.Vector(5, 5, 5);
var mesh = GL.Mesh.sphere({ normals: true, radius: 4 }).computeWireframe();
var shader = new GL.Shader('\
  varying vec3 normal;\
  void main() {\
    normal = gl_Normal;\
    gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;\
  }\
', '\
  uniform float brightness;\
  varying vec3 normal;\
  void main() {\
    gl_FragColor = vec4(brightness * (normal * 0.5 + 0.5), 1.0);\
  }\
');

gl.onmousemove = function(e) {
  //console.log('onmousemove '+require('util').inspect(e));
  if (e.dragging) {
    angleY -= e.deltaX * 0.25;
    angleX = Math.max(-90, Math.min(90, angleX - e.deltaY * 0.25));
  }
};

gl.onupdate = function(seconds) {
  var speed = seconds * 4;

  // Forward movement
  var up = GL.keys.w | GL.keys.UP;
  var down = GL.keys.s | GL.keys.DOWN;
  var forward = GL.Vector.fromAngles((90 - angleY) * Math.PI / 180, (180 - angleX) * Math.PI / 180);
  camera = camera.add(forward.multiply(speed * (up - down)));

  // Sideways movement
  var left = GL.keys.a | GL.keys.LEFT;
  var right = GL.keys.d | GL.keys.RIGHT;
  var sideways = GL.Vector.fromAngles(-angleY * Math.PI / 180, 0);
  camera = camera.add(sideways.multiply(speed * (right - left)));
};

gl.ondraw = function() {
  gl.clear(gl.COLOR_BUFFER_BIT | gl.DEPTH_BUFFER_BIT);
  gl.loadIdentity();
  gl.rotate(-angleX, 1, 0, 0);
  gl.rotate(-angleY, 0, 1, 0);
  gl.translate(-camera.x, -camera.y, -camera.z);

  shader.uniforms({ brightness: 1 }).draw(mesh, gl.TRIANGLES);
  shader.uniforms({ brightness: 0 }).draw(mesh, gl.LINES);
};

gl.fullscreen();
gl.animate();
gl.enable(gl.CULL_FACE);
gl.enable(gl.POLYGON_OFFSET_FILL);
gl.polygonOffset(1, 1);
gl.clearColor(0.8, 0.8, 0.8, 1);
gl.enable(gl.DEPTH_TEST);
